#!/usr/bin/env perl
#
# dcnote-smil :
#   SMIL ե.
#
# Copyright (C) GFD_Dennou_Club, 2001-.  All rights reserved.
#
#  Usage : dcreal-smil.pl
#
#   2001/04/10 ̰ϯ
#       2002/11/27 
#       2003/09/06 ̰ϯ
#       2004/08/16 ͺ    : ݳعѤ˲ (RealPix եʤ)
#       2006/03/31     : 嵭 dcreal ġ뷲
#       2006/04/04     : եνѹȼ
#
#   libjcode-pm-perl ɬ
######################################################################
#Jcode.pm ⥸塼ɤ߹
use Jcode; 
use File::Basename;

#ʸ
$target_code = "euc"; 

# եɤ߹
$CONF = 'dcreal.conf'; 
while (@ARGV) {
    last unless ($ARGV[0] =~ /^-/);
    $_ = shift;                           
    if (/^-c/) { $CONF = shift; next; }; 
    die "unknown option $_";
}
require "$CONF";

#ѤȤƻȤ빭׻
# 2004/08/16 
if ($DOUBLE_MOVIE) {
    $WIDTH = $WIDTH_SLIDE + $WIDTH_PERSON; 
    if ($HEIGHT_SLIDE <= $HEIGHT_PERSON) {
	$HEIGHT = $HEIGHT_PERSON ;
    }else{
	$HEIGHT = $HEIGHT_SLIDE ;
    }
} else {
    $WIDTH = $WIDTH_SLIDE;
    $HEIGHT = $HEIGHT_SLIDE;
}

#Ǽǥ쥯ȥ
$RMDIR = "../$RMDIR"; 
$SMILDIR = "$RMDIR/smi";
$IMGDIR = "$RMDIR/img-real";

#ӥǥ񸻥ǥ쥯ȥ & 
#饤ɥӥǥֱԥӥǥ 2 ĤѰ : 2004/08/17

unless (-d $RMDIR) {
    mkdir $RMDIR, 0777  ;
    $i = 0; 
    while ($TRT_FILES[$i]) {
	if ($RM_FILES_SLIDE[$i] !~ /^$/){
	    print "cd $RMDIR; ln -s ../$SRC/$RM_FILES_SLIDE[$i] ./ \n";
	    system("cd $RMDIR; ln -s ../$SRC/$RM_FILES_SLIDE[$i] ./");
	}
	if ($RM_FILES_PERSON[$i] !~ /^$/){
	    print "cd $RMDIR; ln -s ../$SRC/$RM_FILES_PERSON[$i] ./ \n";
	    system("cd $RMDIR; ln -s ../$SRC/$RM_FILES_PERSON[$i] ./");
	}
	$i++;
    }
}

#SMIL եǼǥ쥯ȥ
mkdir $SMILDIR, 0777  unless -d $SMILDIR ;

#ߥ󥰥ե뤬¸ߤ뤫ǧ
foreach $TRT (@TRT_FILES) {
    unless (-f $TRT) {
	print "  Error: Timing file \"$TRT\" is not found. \n"; 
	exit 1;
    }
}


#ߥ󥰥եΥץ, ɬפʾ.
$i = 0;
$e = 0;
while (@TRT_FILES[$e]) {
    open (TIMING, "$TRT_FILES[$e]");
    $start[$e] = $i;
    while (<TIMING>) {
	chomp(@_);
	#ϻ, OHP ֹ, OHP ȥ̡¸
	$_ =~ /([0-9]+:[0-9]+:[0-9]+),(\d+):(.*)/;
	$time[$i] = $1;
	$ohp_num[$i] = $2;
	($code, $nmatch) = getcode($3);
#	print "$code, $nmatch \n"; 
	$ohp_title[$i] = Jcode::convert($3, $target_code, $code); 
	$end[$e] = $i; 
#	print "$time[$i], $ohp_num[$i], $ohp_title[$i] \n"; 
	$i++;
    }
    $e++;
    close (TIMING);
}
#print "@start, @end \n" ;


# SMIL եκ
$i = 0;
$| = 1; # print ˥եå
$ret = "";
while ($ohp_num[$i]) {
    #ե̾ν
    $num = sprintf("%03d", $ohp_num[$i]);
    
    #˥ե뤬¸ߤʤΤ SMIL ե
    $SMIL = "$SMILDIR/$num.smi";
    
    $e = 0;
    while ($end[$e]) {
	if ($i >= $start[$e]) {
	    $RM_SLIDE = "$RM_FILES_SLIDE[$e]"; 
	    $RM_PERSON = "$RM_FILES_PERSON[$e]"; 
	}
	$e ++;
    }
    unless (-f $SMIL) {
	$ret = "\r" if ($i > 0);
	print "${ret}Making Smil files [$i/$#ohp_num] -> $SMIL";
	print "\n                        :\n" if ($i == 0);
	&print_smi($SMIL, $time[$i], $RM_SLIDE, $RM_PERSON);
    }  
    $i++;
}
print " ... done.\n ";
$| = 0; # ǥեȤΥХåե󥰤᤹

#print "@ohp_num \n";


print basename($0) . ": Successful \n";

exit 0;

#=======================================================================


# SMIL եѥ֥롼
sub print_smi{
    my($smifile, $time, $RM_SLIDE, $RM_PERSON) = @_;
    open (SMIL, ">$smifile");

    #եؤν񤭽Ф. ꡹ѿ. 
    if ($DOUBLE_MOVIE) {
	print SMIL <<EOT
<smil>
<head>
  <meta name="title" content="$TITLE_EN"/>
  <meta name="author" content="$NAME_EN"/>
  <meta name="copyright" content="$COPYRIGHT"/>
  <layout>
    <root-layout width="$WIDTH" height="$HEIGHT"/>
    <region id="slide" top="0" left="0" width="$WIDTH_SLIDE" height="$HEIGHT_SLIDE"/>
    <region id="person" top="0" left="$WIDTH_SLIDE" width="$WIDTH_PERSON" height="$HEIGHT_PERSON"/>
  </layout>
</head>
<body>
  <par>
     <seq>
       <video src="../$RM_SLIDE" region="slide" clip-begin="$time"/>
     </seq>
     <seq>
       <video src="../$RM_PERSON" region="person" clip-begin="$time"/>
     </seq>
  </par>
</body>
</smil>
EOT
;
    }else{
	print SMIL <<EOT
<smil>
<head>
  <meta name="title" content="$TITLE_EN"/>
  <meta name="author" content="$NAME_EN"/>
  <meta name="copyright" content="$COPYRIGHT"/>
  <layout>
    <root-layout width="$WIDTH" height="$HEIGHT"/>
    <region id="slide" top="0" left="0" width="$WIDTH" height="$HEIGHT"/>
  </layout>
</head>
<body>
  <par>
     <seq>
       <video src="../$RM_SLIDE" region="slide" clip-begin="$time"/>
     </seq>
  </par>
</body>
</smil>
EOT
;
    }
    close (SMIL);
}
